diff --git a/src/postgres/src/bin/pg_dump/pg_dump.c b/src/postgres/src/bin/pg_dump/pg_dump.c
index d75e5fddb207..38a308e82bbb 100644
--- a/src/postgres/src/bin/pg_dump/pg_dump.c
+++ b/src/postgres/src/bin/pg_dump/pg_dump.c
@@ -1184,6 +1184,15 @@ setup_connection(Archive *AH, const char *dumpencoding,
 		ExecuteSqlStatement(AH, "SET yb_format_funcs_include_yb_metadata = true");
 	}
 
+	/*
+	 * Hack to avoid issue #12251 which fails if we perform "BEGIN" followed by
+	 * "SET TRANSACTION ISOLATION LEVEL" when yb_enable_read_committed_isolation
+	 * is true.
+	 *
+	 * TODO(Piyush): Remove this hack once the issue is fixed properly
+	 */
+	ExecuteSqlStatement(AH, "SET DEFAULT_TRANSACTION_ISOLATION TO 'repeatable read'");
+
 	/*
 	 * Start transaction-snapshot mode transaction to dump consistent data.
 	 */
